# Move a circle to the position clicked by the user
# Repeat five times
# By CSCI 111

from graphics import *
from time import sleep

STEPS = 100

# create our canvas
win = GraphWin("Circle Shift", 300, 300)

# draw the circle in the middle of the screen
centerPt = Point(win.getWidth()/2, win.getHeight()/2)
circle = Circle( centerPt, 20 )
circle.setFill("blue")
circle.setWidth(0) # no outline
circle.draw(win)

# give the user some instructions
msg = "Click where you want to move the circle."
text = Text( Point(150, 290), msg)
text.draw(win)

for i in xrange(5):
    # Update the instructions
    text.setText(msg + "\nOnly " + str( 5-i) + " more to go")
    
    # The user tells us where to click
    newCenter = win.getMouse()

    # figure out how far the circle needs to move
    dx = newCenter.getX() - centerPt.getX()
    dy = newCenter.getY() - centerPt.getY()

    # move the circle
    for step in xrange(STEPS):
        circle.move( dx/float(STEPS) , dy/float(STEPS) )
        sleep(.05)
    
    
    # get the circle's new center point
    centerPt = circle.getCenter()
    
    
text.setText("Click to exit")
win.getMouse()

