# By CSCI111

class Counter:
    
    """Represents a counter that has a fixed range. It starts at some low value
    and increments by 1. When it reaches the high value, it wraps back around to
    the minimum value. """
    
    def __init__(self, start, stop, currValue):
        self.start = start
        self.stop = stop
        self.currValue = currValue
    
    def __str__(self):
        stringRep = "Current value: " + str(self.currValue)
        return stringRep
    
    def increment(self, incValue = 1):
        """Increment the counter by the given amount, wrapping around to low
        again, if necessary. Returns number of times had to wrap around."""
        
        # Not the most efficient solution, but it's easy to see that it is
        # correct.
        num_wraps = 0
        for x in xrange(incValue):
            if self.currValue < self.stop:
                self.currValue += 1
            else:
                self.currValue = self.start
                num_wraps += 1
        return num_wraps

    def getCurrentValue(self):
        'Returns the current value of this Counter object'
        return self.currValue
    
    def getUpperLimit(self):
        'Returns the upper limit of this Counter object'
        return self.stop
        
    def getLowerLimit(self):
        'Returns the lower limit of this Counter object'
        return self.start
        
    def setValue(self, newValue):
        """ 
        precondition: newValue is an integer between the lower and upper
        limit, inclusive.
        Sets the Counter's current value, if the newValue is within the valid
        range. """
        
        if newValue <= self.stop and newValue >= self.start:
            self.currValue = newValue
        else:  
            # Error message
            print newValue, "is not within valid range: ", self.start, self.stop

def main():
    counter = Counter(1, 12, 2)
    print counter
    
    for x in xrange(12):
        counter.increment(13)
        print counter
     
       
main() 
