# Encodes a phrase entered by a user
# Modified by CS111 to use Counter class

import sys
from counter import *

KEY_BOUND=25
MIN_ASCII=ord('a')
MAX_ASCII=ord('z')
ASCII_SHIFT = 26

def main():
    print "This program encodes and decodes Caesar ciphers\n"

    text = raw_input("Enter some text: ")
    key = input("Enter an integer key (between -25 and 25): ")
    
    # make sure it's a valid key
    if key < -KEY_BOUND or key > KEY_BOUND:
        print "Invalid key!"
        sys.exit(1)
    
    message = encoder(text,key)
    print message

# takes in some text and integer key (between -25 and 25,
# inclusive) and returns encoded message
def encoder(text,key):
    message=""
    for ch in text:
        if ch == " ":
            encode= " "
            message+=encode
        else:
            message += translateLetter(ch,key)
    return message

# takes in a letter and integer key (between -25 and
# 25, inclusive) and returns the encoded letter
def translateLetter(letter,key):
    
    counter = Counter( MIN_ASCII, MAX_ASCII, ord(letter) )
    if key > 0:
        counter.increment(key)
    else:
        counter.decrement(key)
        
    newASCIIValue = counter.getCurrentValue()
    
    return chr(newASCIIValue)
    
#call main function
main()
