# Compare the linear and binary searching techniques by the number of
# comparisons.
# by Sara Sprenkle

def main():

    print "This program helps us to empirically compare search strategies"
    print

    # The keys I want to search for in a list
    #keys = [1, 4, 13, 19, 125, 126, 127]
    keys = [1, 4, 13, 19, 125, 126, 127, 19997, 19998, 19999]

    NUM_ENTRIES = 10000
    
    # the list of integers that I'm searching (odd numbers)
    integers = range(1,NUM_ENTRIES*2,2)
    #print integers
    print "Creating list of size", NUM_ENTRIES*2, "starting at 1 and incrementing by 2"
    print

    print "%6s|%14s" % ("","# Comparisons")
    print "%6s| %6s %6s" % ("KEY", "LIN", "BIN")
    print "-"* 24
    
    total_lin_comp = 0.0
    total_bin_comp = 0.0
    
    for key in keys:
        lin_comp = linearSearch(integers,key)
        bin_comp = binarySearch(integers,key)
        print "%6d| %6d %6d" % (key, lin_comp, bin_comp)
        
        # update the total number of comparisons
        total_lin_comp += lin_comp
        total_bin_comp += bin_comp
    
    print 
    print "ON AVERAGE..."
    print "-"*50
    print
    print "The average number of comparisons per search for"
    print "\tlinear search was", total_lin_comp/len(keys)
    print "\tbinary search was", total_bin_comp/len(keys)
    print
    print "Disclaimer: May not be a completely fair comparison but gives us an idea."


# Return the number of comparisons required to find the key.
def linearSearch(searchlist, key):
    numChecks = 0
    for elem in searchlist:
        numChecks += 1
        if elem == key:
            return numChecks
    return numChecks

# Return the number of comparisons required to find the key
def binarySearch(searchlist, key):
    low = 0
    high = len(searchlist)-1
    numChecks = 0
    while low <= high:
        mid = (low+high)/2
        numChecks+= 2  # while comparison, next if comparison
        if searchlist[mid] == key:
            return numChecks
        numChecks+=1
        if searchlist[mid] < key:
            low = mid+1
        else:
            high = mid-1
    return numChecks

main()
