import csplot

""" Module of Board Games """

class ConnectFour:
    """ Class representing the game Connect Four. """
    
    # Define constants to be used throughout this class
    FREE = 0
    PLAYER1 = 1
    PLAYER2 = 2

    ROWS = 6
    COLS = 7

    # dictionary of number-->color mappings
    repToColor = {FREE:'yellow', PLAYER1:'red', PLAYER2:'black'}

    def __init__(self):
        self.board = createBoard(ConnectFour.ROWS, ConnectFour.COLS)
        self.num_moves = 0

    def _isValidMove(self, col):
        """ Return True iff the dropping a checker in this col (an int)
        represents a valid move. """
        if self.board[ConnectFour.ROWS-1][col] == ConnectFour.FREE:
            return True
        return False

    #def makeMove(self, whichplayer, col):
    #    """Change the board so that 'whichplayer' occupies the next (vertical) spot
    #    in the column.  Return the y-position (row) that the checker is in."""

    def showBoard(self):
        csplot.show(self.board, ConnectFour.repToColor)

    #def _isDraw(self):
    #    """ Return True iff the game is a draw because there are no
    #    free/empty spots."""
    
    
    # def _isWon(self, row, col):
    #    """ Return True if the most recent player won."""
        
       # whichplayer = self.board[row][col]
       # look around position [row][col] to determine if
       # 'whichplayer' won.

    def play(self):
        won = False
        player = ConnectFour.PLAYER1
        
        # also handle draws ...
        
        while not won:
            print "Player %d's move" % player
            col = csplot.sqinput()
            validMove = self._isValidMove(col)
            while not validMove:
                print "NOT A VALID MOVE."
                print "PLEASE SELECT AGAIN."
                print
                col = csplot.sqinput()
                validMove = self._isValidMove(col)

            # LAB 11: After implementing the makeMove method above,
            # uncomment the next two lines and test your program
            
            #ypos = self.makeMove(player, col)
            #self.showBoard()
            #won = self._isWon(ypos, col)
            
            # alternate players
            player = player % 2 + 1
        

class Checkers:
    """ Class representing the checkers game. """

    VALID = 0
    NOTVALID = -1
    PLAYER1 = 1
    PLAYER2 = 2
    
    # dictionary of number-->color mappings
    repToColor = {VALID:'white', PLAYER1:'red', PLAYER2:'black', NOTVALID:'gray'}

    def __init__(self):
        self.board = createBoard(8,8)
        
        for x in xrange(8):
            for y in xrange((x+1)%2, 8, 2):
                self.board[x][y] = Checkers.NOTVALID

        for x in xrange(3):
            for y in xrange(x%2, 8, 2):
                self.board[x][y] = Checkers.PLAYER1

        for x in xrange(5, 8):
            for y in xrange(x%2, 8, 2):
                self.board[x][y] = Checkers.PLAYER2


        print self.board
    
    def showBoard(self):
        print self.board
        csplot.show(self.board, Checkers.repToColor)

def createBoard(height, width):
    """Returns a board (2D list) with the passed in width and
    height."""
    
    board = []
    for x in xrange(height):
        board.append(createOneRow(width))
    return board

            
def createOneRow( n ):
    """ Returns list of n zeros """
    row = []
    for col in xrange(n):
        row.append(0)
    return row



def testCheckers():
    game = Checkers()
    game.showBoard()

    csplot.winput()

#testCheckers()

