# Demonstrate that MyTunes works
# Sara Sprenkle

from music import *
import sys

def main():

    DEFAULT = "libraries/mytunes.library"

    # if user gives the name of the library file
    if len(sys.argv) == 2:
        filename = sys.argv[1]
    else:
        filename = DEFAULT

    # Create the music library 
    library = MusicLibrary(filename)

    OPTIONS=["v", "i", "s", "q", "x"]
    
    while True:
        displayUserOptions()
        option = raw_input("Which option do you want? ")
        option = option.lower()
        while option not in OPTIONS:
            print "That is not a valid option."
            option = raw_input("Select an option: ")
            option = option.lower()
        # do option
        print
        if option == "v":
            library.prettyPrint()
        elif option == "s":
            library.sort()
            library.prettyPrint()
        elif option == "i":
            albumname = raw_input("What is the name of the album you want to import? ")
            library.importAlbum(albumname)
        elif option == "x":
            exportfile = raw_input("What is the name of the file that you want to export the library to? ")
            library.storeLibrary(exportfile)
        else:
            break

    library.storeLibrary()

def displayUserOptions():
    print "*************************************"
    print "Select one of the following options:"
    print "\t(V)iew the library"
    print "\t(I)mport songs into the library"
    print "\t(S)ort the library"
    print "\tE(X)port the library to a file"
    print "\t(Q)uit the program"
    
main()
